<template>
  <div @keyup.enter="sendDataOfUser">
    <div :class="[activeClass, {disabledBlock:hasBlock}]">
      <form-of-dispatch ref="form"></form-of-dispatch>
    </div>

    <sms-form v-if="confirmation"
              v-model="$user.smsCode"
              @change="handleSms"
              @resend="againSms"
              :timeOut="60"
              ref="smsForm"
              @enter="sendDataOfUser"
    >
      <template slot="title">Подтверждение номера телефона</template>
      <template slot="'additional-title'">
        На номер <strong>{{$user.mobilePhone}}</strong> было отправлено СМС с кодом подтверждения. Введите полученный код, чтобы продолжить оформление заявки.</template>
      <template slot="change">
        <div class="columns six" v-if="$user.smsSend.total < 5">
          <div>
            <a @click.prevent="changePhone" class="redefine-phone">Изменить номер телефона</a>
          </div>
        </div>
      </template>
      <template slot="agreement">
        <div class="checkbox">
          <ui-checkbox v-model="compliance" style="margin-right: -5px"></ui-checkbox>
          <span @click="compliance = !compliance">
            Я даю согласие на <a href="#" @click.stop.prevent="showMe" class="cursor-pointer">обработку</a> и хранение моих персональных данных.
          </span>
        </div>
      </template>
    </sms-form>



    <div class="center">
      <error-block :errors="errors" @clear="errors = []"></error-block>
      <warning-message></warning-message>
      <button @click="sendDataOfUser" :disabled="$interface.buttonLoading || !compliance" :class="{button_loading: $interface.buttonLoading}">{{nameButton}}</button>
    </div>
    <consent-to-the-processing-of-personal-data></consent-to-the-processing-of-personal-data>
    <modal name="show-sms-message" height="auto">
      <div class="container">
        <h3 class="center">Код подтверждения успешно отправлен в SMS</h3>
      </div>
    </modal>
    <modal name="modal-lk-exists" height="auto" :minWidth="300"
           :resizable="true"
           :adaptive="true"
           :reset="true"
           :delay="1">
      <div class="container no-padding">
        <div class="container m-header">
          <div @click="$modal.hide('modal-lk-exists')" class="box-modal_close arcticmodal-close"></div>
          <div class="row">
            <div class="column" style="margin:0;padding:0">
              <h3 class="center">Номер телефона уже существует в системе</h3>
            </div>
          </div>
        </div>
        <div class="container">
          <div class="row">
            <div class="columns twelve center">
              <button class="blue" @click="$router.push('/login')">Войти в ЛК</button>
            </div>
          </div>
        </div>
      </div>
    </modal>

    <restore-password></restore-password>
  </div>

</template>

<script>
    import UserGetter from '@/mixins/User/UserGetterMixin'
    import UserSetter from '@/mixins/User/UserSetterMixin'
    import UserErrorText from '@/mixins/User/UserErrorTextMixin'
    import IndicatorRegistration from '@/mixins/IndicatorRegistration'
    import ValidateMessage from '@/components/Validators/ValidateMessage'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import FormOfDispatch from './FormOfDispatch'
    import PersonalInformation from '@/components/User/PersonalInformation'
    import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
    import {REQUIRED_FIELD, LENGHT} from '@/components/Validators/CustomVeeValidateMessage'
    import ConsentToTheProcessingOfPersonalData from './ConsentToTheProcessingOfPersonalData'
    import RestorePassword from '@/pages/Login/RestorePassword'
    import backendApi from '@/utils/backend-api'
    import SmsForm from '@/components/SmsForm'
    import ErrorLog from '@/mixins/ErrorLog.js'
	import UserRegisterSms from '@/mixins/User/UserRegisterSms'
    export default {
        name: 'first-page',
        mixins: [
            UserGetter,
            UserSetter,
            UserErrorText,
            IndicatorRegistration,
            GetValidateClass,
            ErrorLog,
			UserRegisterSms,
        ],
		components: {
			FormOfDispatch,
			PersonalInformation,
			ValidateMessage,
			ConsentToTheProcessingOfPersonalData,
			WarningMessage,
			RestorePassword,
			SmsForm
		},
        data () {
            return {
                confirmation: false,
                activeClass: 'white-block',
                hasBlock: false,
                compliance: true,
                processingAgree: false,
                smsCode: '',
                errors: [],
                accession: true,
                allFields: false,
                showVuexError: 'block',
                changePhoneBlocked: false,
                mobilePhoneNotUnique: false,
                notAgree: false,
            }
        },
        created () {
            if (this.getRegisterSmsSendByPhoneCount) {
                this.confirmation = true
                this.hasBlock = true
            }
            // если уже отправлено 5-смс. то показываем ссылку на помощь
            /*if (this.$user.smsSend.total >= 5) {
              this.$store.commit('CALL_WARNING_WINDOW', this.$store.state.errorMessagesWithChatHelp.smsLimit)
            }*/

            this.$user.smsCode = '';
          document.location.hash = 'step1';

        },
        computed: {
            agree () {
                return (this.compliance) && this.$validate.step1 && this.accession;
            },
            nameButton () {
                return this.confirmation ? 'Подтвердить' : 'Продолжить'
            }
        },
        watch: {
            '$user.mobilePhone' (phone) {
                phone = phone.replace(/[^\d]/g, '')
                if (phone && phone.length === 11) {
                    this.checkMobilePhone()
                }
                this.$user.smsSend.phone = 0;
            },
            getRegisterSmsSendCount (count) {
                if (count > 4) {
                    this.$store.commit('CALL_WARNING_WINDOW', this.$store.state.errorMessagesWithChatHelp.smsLimit)
                }
            }
        },

        mounted () {
            this.$validator.localize(REQUIRED_FIELD)
            this.$validator.localize(LENGHT)
            if (this.$user.mobilePhone && this.$user.mobilePhone.replace(/[^\d]/g, '').length === 11) {
                this.checkMobilePhone()
            }
            // если уже высылали код, то делаем фокус на форму
            if (this.confirmation) {
                this.scrollForm()
                this.$refs.smsForm.$refs.smsCodeInput.focus()
            }
        },

        methods: {
            handleSms (sms) {
                this.smsCode = sms;
            },
            openChat () {
                try {
                    document.querySelector('.sender-connect-button').click();
                } catch (e) {}
            },

            checkMobilePhone () {
                this.$backend.api.user.verify({
                    mobilePhone: this.$user.mobilePhone.replace(/[^\d]/g, '')
                }).then((response) => {
                    this.mobilePhoneNotUnique = false
                }).catch((e) => {
                    if (e.errors && e.errors[0].code === 'mobilePhoneNotUnique') {
                        this.mobilePhoneNotUnique = true
                    } else {
                        this.mobilePhoneNotUnique = false
                    }
                })
            },
            showMe () {
                this.$modal.show('consent');
            },
            hideMe () {
                this.$modal.hide('consent');
            },
            accessForm () {
                this.accession = false
                // this.nameButton = 'Подтвердить'
                //

                if (this.hasBlock) {
                    if (this.$user.smsCode.length === 4) {
                        this.$user.regStep = 2;
                        document.location.hash = 'step2';
                        this.$backend.log({
                            lk_log: 'stats',
                            reg_step: 1,
                            user_hash: this.$user.hash,
                            user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
                            user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
                        });

                        if(window.wbEvent) window.wbEvent.send('USER_REGISTER_NEXT');
                        if (window.yaCounter17582872) window.yaCounter17582872.reachGoal('USER_REGISTER_NEXT');

                        window.Analityc.reg_step1a();

                    }
                    return true
                } else {
                    this.confirmation = true
                    this.hasBlock = true
                    this.$nextTick(() => {
                        this.$refs.smsForm.$refs.smsCodeInput.focus()
                        this.scrollForm();
                        window.Analityc.reg_step1();
                    })
                }
            },
            changePhone () {
                if (this.$user.smsSend.total >= 5) {
                    this.$store.commit('CALL_WARNING_WINDOW', this.$store.state.errorMessagesWithChatHelp.changePhoneError)
                    return
                }
                this.hasBlock = false
                this.confirmation = false
                this.accession = true
                this.backTime = true
                // this.nameButton = 'Продолжить'
                this.$refs.form.$refs.ContactMobilePhone.$refs.mobilePhone.focus()
                this.compliance = true
                this.$user.smsCode = ''
                this.processingAgree = false
            },
            checkInCompliance () {
                this.compliance = !this.compliance
                if (!this.compliance) {
                    this.processingAgree = true
                } else {
                    this.processingAgree = false
                }
            },
            checkCode () {
                this.$user.smsCode.length === 4 ? this.accession = true : this.accession = false
            },
            scrollForm () {
                this.$helpers.scroll(this.$refs.smsForm.$el);
            }
        },

    }
</script>

<style scoped lang="scss">
  .no-padding {
    padding: 0;
  }

    .disabledBlock {
        pointer-events: none;
        opacity: 0.4;
    }

    .red {
        color: #f00;
    }

    .margin-top_-30 {
        margin-top: -30px;
    }

    .error {
        background: #fff0ed;
        color: #ff6d4a;
        border-color: #ffd6ce !important;
    }

    .after-time, .redefine-phone {
        cursor: pointer;
    }

    .refresh-code.after-time:hover, .redefine-phone:hover {
        text-decoration: underline;
    }

    .v--modal {
        height: 100% !important
    }

    .red {
        color: red
    }

    .cursor-pointer {
      position: relative;
    }
    .cursor-pointer:hover {
      cursor: pointer;
    }
</style>



